/* Copyright (c) 2020, EPFL/Blue Brain Project
 *                          Nadir Román Guerrero <nadir.romanguerrero@epfl.ch>
 *
 * This file is part of Brion <https://github.com/BlueBrain/Brion>
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License version 3.0 as published
 * by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef BRAIN_H
#define BRAIN_H

#include <brain/api.h>
#include <brain/circuit.h>
#include <brain/compartmentReport.h>
#include <brain/compartmentReportMapping.h>
#include <brain/compartmentReportView.h>
#include <brain/log.h>
#include <brain/neuron/morphology.h>
#include <brain/neuron/section.h>
#include <brain/neuron/soma.h>
#include <brain/neuron/types.h>
#include <brain/simulation.h>
#include <brain/spikeReportReader.h>
#include <brain/spikeReportWriter.h>
#include <brain/synapse.h>
#include <brain/synapses.h>
#include <brain/synapsesIterator.h>
#include <brain/synapsesStream.h>
#include <brain/types.h>
#include <brain/version.h>

#endif
